package cc.smtweb.system.bpm.test;

import cc.smtweb.system.bpm.util.CodeGenUtil;
import org.apache.commons.lang3.StringUtils;
import org.junit.Test;

/**
 * Created by Akmm at 2022/3/1 9:41
 * 生成bean
 */
public class BuildJavaBean {
    @Test
    public void buildBean() {
        String str = "`mc_id` bigint(20) NOT NULL,\n" +
                "  `mc_parent_id` bigint(20) DEFAULT NULL COMMENT '-1',\n" +
                "  `mc_code` varchar(20) COLLATE utf8_unicode_ci DEFAULT NULL,\n" +
                "  `mc_name` varchar(50) COLLATE utf8_unicode_ci NOT NULL COMMENT '项目名称',\n" +
                "  `mc_prj_id` bigint(20) NOT NULL DEFAULT '-1',\n" +
                "  `mc_create_uid` bigint(20) DEFAULT NULL,\n" +
                "  `mc_update_uid` bigint(20) DEFAULT NULL,\n" +
                "  `mc_create_at` bigint(20) NOT NULL DEFAULT '0',\n" +
                "  `mc_update_at` bigint(20) NOT NULL DEFAULT '0',";
        String[] ss = str.split("\n");
        for (String s: ss) {
            String[] s0 = s.trim().split(" ");
            if (StringUtils.isEmpty(s0[0])) continue;
            String tn = s0[0].substring(1, s0[0].indexOf("`", 2));
            String tnu = CodeGenUtil.underlineToUpperHump(tn);
            String tnn = CodeGenUtil.underlineToHump(tn);

            String tt = s0[1];
            String ttj;
            if (tt.contains("(")) tt = tt.substring(0, tt.indexOf("("));
            switch (tt) {
                case "bigint":
                    tt = "long";
                    ttj = "Long";
                    break;
                case "tinyint":
                    case "int":
                    tt = "int";
                    ttj = "Int";
                    break;
                default:
                    tt = "String";
                    ttj = "Str";
                    break;
            }
            System.out.println("private " + tt + " get" + tnu + "(){\n" +
                    "return get" + ttj + "(\"" + tn + "\");\n" +
                    "}\n" +
                    "" +
                    "private void set" + tnu + "(" + tt + " " + tnn + "){\n" +
                    "put(\"" + tn + "\", " + tnn + ");\n" +
                    "}\n");
        }
    }
}
